// Moogfest 2019 workshop 8 oscillator test
// Miles DeCoster
// 8 oscillators with separate frequency and volume settings

var masterGain;
var osc = [];
var gain = [];
var fknobs = [];
var gknobs = [];
var freq = [];
var myType = ['sine', 'triangle', ' square', 'sawtooth'];
var pointerCursor = false; // referenced in knobMaker and padMaker

function setup() { 
  createCanvas(900, 500);
  background(100);
  masterGain = new p5.Gain();
  masterGain.connect();
  masterGain.amp(1);
  // make 8 oscillators with random types and 8 knobs to control frequency of each
  for (i = 0; i < 8; i++) {
    fknobs[i] = new MakeKnob("knobMF.png", 50, 60+(i*100), 70, 40, 1600, 40, 2, "Frequency");
    myNum=int(floor(random(5)));
    osc[i] = new p5.Oscillator(myType[myNum]);
    //osc[i].amp(1);
    osc[i].connect(masterGain);
    osc[i].disconnect();
    osc[i].start();
  }
  
  // make 8 knobs to control volume of each oscillator
  for (i = 0; i < 8; i++) {
    gknobs[i] = new MakeKnob("knobMF.png", 50, 60+(i*100), 200, 0, 1, 0, 2, "Volume");
    gain[i] = new p5.Gain();
    gain[i].setInput(osc[i]);
    gain[i].connect(masterGain);
  }
  
} // end setup

function draw() {
  background(100);
  pointerCursor = false;
  for (i = 0; i < 8; i++) {
    fknobs[i].update();
    osc[i].freq(fknobs[i].knobValue);
    gknobs[i].update();
    gain[i].amp(gknobs[i].knobValue);
  }
  // cursor check
  if (pointerCursor) { cursor('pointer'); } else { cursor('default'); }
} // end draw

function mousePressed() {
  for (i = 0; i < 8; i++) {
      fknobs[i].active();
      gknobs[i].active();
  }
}

function mouseReleased() {
  for (i = 0; i < 8; i++) {
      fknobs[i].inactive();
      gknobs[i].inactive();
  }
}
